    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2011, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Oracle and Java are registered trademarks of Oracle and/or its affiliates.
    025     * Other names may be trademarks of their respective owners.]
    026     *
    027     * -----------------
    028     * ImageEncoder.java
    029     * -----------------
    030     * (C) Copyright 2004-2008, by Richard Atkinson and Contributors.
    031     *
    032     * Original Author:  Richard Atkinson;
    033     * Contributor(s):   -;
    034     *
    035     * Changes
    036     * -------
    037     * 01-Aug-2004 : Initial version (RA);
    038     * 02-Feb-2007 : Removed author tags all over JFreeChart sources (DG);
    039     *
    040     */
    041
    042    package org.jfree.chart.encoders;
    043
    044    import java.awt.image.BufferedImage;
    045    import java.io.IOException;
    046    import java.io.OutputStream;
    047
    048    /**
    049     * Interface for abstracting different types of image encoders.
    050     */
    051    public interface ImageEncoder {
    052
    053        /**
    054         * Encodes an image in a particular format.
    055         *
    056         * @param bufferedImage  The image to be encoded.
    057         *
    058         * @return The byte[] that is the encoded image.
    059         *
    060         * @throws IOException
    061         */
    062        public byte[] encode(BufferedImage bufferedImage) throws IOException;
    063
    064
    065        /**
    066         * Encodes an image in a particular format and writes it to an OutputStream.
    067         *
    068         * @param bufferedImage  The image to be encoded.
    069         * @param outputStream  The OutputStream to write the encoded image to.
    070         * @throws IOException
    071         */
    072        public void encode(BufferedImage bufferedImage, OutputStream outputStream)
    073            throws IOException;
    074
    075        /**
    076         * Get the quality of the image encoding.
    077         *
    078         * @return A float representing the quality.
    079         */
    080        public float getQuality();
    081
    082        /**
    083         * Set the quality of the image encoding (not supported by all
    084         * ImageEncoders).
    085         *
    086         * @param quality  A float representing the quality.
    087         */
    088        public void setQuality(float quality);
    089
    090        /**
    091         * Get whether the encoder should encode alpha transparency.
    092         *
    093         * @return Whether the encoder is encoding alpha transparency.
    094         */
    095        public boolean isEncodingAlpha();
    096
    097        /**
    098         * Set whether the encoder should encode alpha transparency (not
    099         * supported by all ImageEncoders).
    100         *
    101         * @param encodingAlpha  Whether the encoder should encode alpha
    102         *                       transparency.
    103         */
    104        public void setEncodingAlpha(boolean encodingAlpha);
    105
    106    }